<%-- 
    Mi Tienda Pagadito 4.0 (API JAVA)
    Es un ejemplo de plataforma de e-commerce, que realiza venta de productos
    electrnicos, y efecta los cobros utilizando Pagadito, a travs de la API.
 
    cobro.jsp
 
    Este script procesa la transaccin a peticin del script index.jsp. Se
    comunica con el WSPG para conectarse y registrar la transaccin.
 
    LICENCIA: ste cdigo fuente es de uso libre. Su comercializacin no est
    permitida. Toda publicacin o mencin del mismo, debe ser referenciada a
    su autor original Pagadito.com.
 
    @author      Pagadito.com <soporte@pagadito.com>
    @copyright   Copyright (c) 2012, Pagadito.com
    @version     1.0
    @link        https://dev.pagadito.com/index.php?mod=docs&hac=apipg#java
--%>

<%@page import="com.pagadito.apipg.Pagadito"%>
<%@page import="java.net.URLDecoder"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.AbstractList"%>
<%@page import="java.util.List"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Map"%>
<%@page import="java.io.StringReader"%>
<%@page import="org.xml.sax.InputSource"%>
<%@page import="javax.xml.parsers.*"%>
<%@page import="org.w3c.dom.*"%>
<%--
    Se incluye el script config.js que contiene las constantes de conexin.
--%>
<%@include file="config.jsp"%>
<%
    if(request.getParameter("cantidad1") != "" && request.getParameter("cantidad2") != "" && request.getParameter("cantidad3") != ""){
        Integer cantidad1 = 0;
        Integer cantidad2 = 0;
        Integer cantidad3 = 0;
        try{
            cantidad1 = Integer.parseInt(request.getParameter("cantidad1"));
            cantidad2 = Integer.parseInt(request.getParameter("cantidad2"));
            cantidad3 = Integer.parseInt(request.getParameter("cantidad3"));
        }
        catch(Exception err){
            out.println(""
                + "<script>"
                + "     alert('No ha llenado los campos adecuadamente.');"
                + "     location.href = 'index.jsp';"
                + "</script>");
        }
        /*
         * Lo primero es crear el objeto Pagadito, al que se le pasa como
         * parmetros el UID y el WSK definidos en config.php
         */
        Pagadito Pagadito = new Pagadito(UID, WSK);
        /*
         * Si se est realizando pruebas, necesita conectarse con Pagadito SandBox. Para ello llamamos
         * a la funcin mode_sandbox_on(). De lo contrario omitir la siguiente linea.
         */
        Pagadito.mode_sandbox_on();
        if(Pagadito.connect()){
            if(cantidad1 > 0){
                Pagadito.add_detail(cantidad1, request.getParameter("descripcion1"), Double.parseDouble(request.getParameter("precio1")), request.getParameter("url1"));
            }
            if(cantidad2 > 0){
                Pagadito.add_detail(cantidad2, request.getParameter("descripcion2"), Double.parseDouble(request.getParameter("precio2")), request.getParameter("url2"));
            }
            if(cantidad3 > 0){
                Pagadito.add_detail(cantidad3, request.getParameter("descripcion3"), Double.parseDouble(request.getParameter("precio3")), request.getParameter("url3"));
            }
            if(Pagadito.exec_trans(request.getParameter("ern"))){
                response.sendRedirect(URLDecoder.decode(Pagadito.get_rs_value()));
            }
            else{
                /*
                 * En caso de fallar la transaccin, verificamos el error devuelto.
                 * Debido a que la API nos puede devolver diversos mensajes de
                 * respuesta, validamos el tipo de mensaje que nos devuelve.
                 */
                if(Pagadito.get_rs_code().equals("PG2001")){
                    /*Incomplete data*/
                    out.println(""
                        + "<script>"
                        + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                        + "     location.href = 'index.jsp';"
                        + "</script>");
                }
                else if(Pagadito.get_rs_code().equals("PG3002")){
                    /*Error*/
                    out.println(""
                        + "<script>"
                        + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                        + "     location.href = 'index.jsp';"
                        + "</script>");
                }
                else if(Pagadito.get_rs_code().equals("PG3003")){
                    /*Unregistered transaction*/
                    out.println(""
                        + "<script>"
                        + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                        + "     location.href = 'index.jsp';"
                        + "</script>");
                }
                else if(Pagadito.get_rs_code().equals("PG3004")){
                    /*Match error*/
                    out.println(""
                        + "<script>"
                        + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                        + "     location.href = 'index.jsp';"
                        + "</script>");
                }
                else if(Pagadito.get_rs_code().equals("PG3005")){
                    /*Disabled connection*/
                    out.println(""
                        + "<script>"
                        + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                        + "     location.href = 'index.jsp';"
                        + "</script>");
                }
                else{
                    out.println(""
                        + "<script>"
                        + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                        + "     location.href = 'index.jsp';"
                        + "</script>");
                }
            }
        }
        else{
            /*
             * En caso de fallar la conexin, verificamos el error devuelto.
             * Debido a que la API nos puede devolver diversos mensajes de
             * respuesta, validamos el tipo de mensaje que nos devuelve.
             */
            if(Pagadito.get_rs_code().equals("PG2001")){
                /*Incomplete data*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3001")){
                /*Problem connection*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3002")){
                /*Error*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3003")){
                /*Unregistered transaction*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3005")){
                /*Disabled connection*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3006")){
                /*Exceeded*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else{
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
        }
    }
    else{
        out.println(""
                + "<script>"
                + "     alert('No ha llenado los campos adecuadamente.');"
                + "     location.href = 'index.jsp';"
                + "</script>");
    }
%>