<%-- 
    Mi Tienda Pagadito 4.0 (API JAVA)
    Es un ejemplo de plataforma de e-commerce, que realiza venta de productos
    electrónicos, y efectúa los cobros utilizando Pagadito, a través de la API.
 
    payback.jsp
 
    Este script recibe la redirección desde Pagadito una vez la transacción ha
    sido finalizada. Se conecta al WSPG y consulta el estado de la transacción.
 
    LICENCIA: Éste código fuente es de uso libre. Su comercialización no está
    permitida. Toda publicación o mención del mismo, debe ser referenciada a
    su autor original Pagadito.com.
 
    @author      Pagadito.com <soporte@pagadito.com>
    @copyright   Copyright (c) 2012, Pagadito.com
    @version     1.0
    @link        https://dev.pagadito.com/index.php?mod=docs&hac=apipg#java
--%>
<%@page import="com.pagadito.apipg.Pagadito"%>
<%@page import="java.net.URLDecoder"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.AbstractList"%>
<%@page import="java.util.List"%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Map"%>
<%@page import="java.io.StringReader"%>
<%@page import="org.xml.sax.InputSource"%>
<%@page import="javax.xml.parsers.*"%>
<%@page import="org.w3c.dom.*"%>
<%--
    Se incluye el script config.js que contiene las constantes de conexión.
--%>
<%@include file="config.jsp"%>
<%
    String msg = "";
    if(request.getParameter("token") != ""){
        /*
         * Lo primero es crear el objeto Pagadito, al que se le pasa como
         * parámetros el UID y el WSK definidos en config.php
         */
        Pagadito Pagadito = new Pagadito(UID, WSK);
        /*
         * Si se está realizando pruebas, necesita conectarse con Pagadito SandBox. Para ello llamamos
         * a la función mode_sandbox_on(). De lo contrario omitir la siguiente linea.
         */
        Pagadito.mode_sandbox_on();
        if(Pagadito.connect()){
            if(Pagadito.get_status(request.getParameter("token"))){
                if(Pagadito.get_rs_status().equals("COMPLETED")){
                    /*
                     * Tratamiento para una transacción exitosa.
                     */
                    msg = "Gracias por comprar en Mi Tienda Pagadito.<br /><br />Referencia: " + Pagadito.get_rs_reference() + "<br />Fecha: " + Pagadito.get_rs_date_trans();
                }
                else if(Pagadito.get_rs_status().equals("REGISTERED")){
                    /*
                     * Tratamiento para una transacción aún en
                     * proceso.
                     */
                    msg = "La transacci&oacute;n a&uacute;n est&aacute; en proceso.";
                }
                else if(Pagadito.get_rs_status().equals("FAILED")){
                    /*
                     * Tratamiento para una transacción fallida.
                     */
                    msg = "Lo sentimos, la compra no pudo realizarse.";
                }
                else{
                    msg = "Lo sentimos, la compra no pudo realizarse.";
                }
            }
            else{
                msg = "Lo sentimos, la compra no pudo realizarse.";
            }
        }
        else{
            /*
             * En caso de fallar la conexión, verificamos el error devuelto.
             * Debido a que la API nos puede devolver diversos mensajes de
             * respuesta, validamos el tipo de mensaje que nos devuelve.
             */
            if(Pagadito.get_rs_code().equals("PG2001")){
                /*Incomplete data*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3001")){
                /*Problem connection*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3002")){
                /*Error*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3003")){
                /*Unregistered transaction*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3005")){
                /*Disabled connection*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else if(Pagadito.get_rs_code().equals("PG3006")){
                /*Exceeded*/
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
            else{
                out.println(""
                    + "<script>"
                    + "     alert(\"" + Pagadito.get_rs_code() + ": " + Pagadito.get_rs_message() + "\");"
                    + "     location.href = 'index.jsp';"
                    + "</script>");
            }
        }
    }
    else{
        out.println(""
            + "<script>"
            + "     alert('No se han recibido los datos correctamente.');"
            + "     location.href = 'index.jsp';"
            + "</script>");
    }
%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<html>
    <head>
        <title>Mi Tienda Pagadito</title>
        <link type="text/css" rel="stylesheet" href="css/default.css" media="screen" />
    </head>
    <body>
        <div id="topBar">
            <div id="center">
                <div id="site"></div>
                <div class="clear"></div>
            </div>
        </div>
        <div id="wrapper">
            <div id="header">
                <img id="logo" src="imagenes/logo.png" title="Mi Tienda Pagadito" alt="Mi Tienda Pagadito" />
            </div>
            <div id="content">
                <br />
                <%=msg%>
                <br />
                <a href="index.jsp">Volver a comprar</a>
            </div>
        </div>
    </body>
</html>
